import { IFramebuffer, IModel, IModelUniform, IRenderOptions, ITexture2D } from '@antv/l7-core';
import 'reflect-metadata';
import BaseModel from '../../core/BaseModel';
export default class HeatMapModel extends BaseModel {
    protected texture: ITexture2D;
    protected colorTexture: ITexture2D;
    protected heatmapFramerBuffer: IFramebuffer;
    private intensityModel;
    private colorModel;
    private shapeType;
    private preRampColors;
    render(options: Partial<IRenderOptions>): void;
    getUninforms(): IModelUniform;
    initModels(): Promise<IModel[]>;
    buildModels(): Promise<IModel[]>;
    protected registerBuiltinAttributes(): void;
    private buildHeatMapIntensity;
    private buildHeatmapColor;
    private drawIntensityMode;
    private drawColorMode;
    private draw3DHeatMap;
    private build3dHeatMap;
    private updateStyle;
    private updateColorTexture;
}
