import { IAnimateOption, IAttribute, IElements, IModel, IModelUniform } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class FillModel extends BaseModel {
    getUninforms(): IModelUniform;
    getAnimateUniforms(): IModelUniform;
    getAttribute(): {
        attributes: {
            [attributeName: string]: IAttribute;
        };
        elements: IElements;
    };
    initModels(): Promise<IModel[]>;
    buildModels(): Promise<IModel[]>;
    /**
     * 根据 animateOption 的值返回对应的 shader 代码
     * @returns
     */
    getShaders(animateOption: Partial<IAnimateOption>): {
        frag: string;
        vert: string;
        type: string;
    };
    protected animateOption2Array(option: Partial<IAnimateOption>): number[];
    protected registerBuiltinAttributes(): void;
}
