import { IModel, ITexture2D } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class ExtrudeModel extends BaseModel {
    protected texture: ITexture2D;
    getUninforms(): {
        u_topsurface: number;
        u_sidesurface: number;
        u_heightfixed: number;
        u_raisingHeight: number;
        u_linearColor: number;
        u_sourceColor: number[];
        u_targetColor: number[];
        u_texture: ITexture2D;
    };
    initModels(): Promise<IModel[]>;
    buildModels(): Promise<IModel[]>;
    getShaders(): {
        frag: string;
        vert: string;
        type: string;
    };
    clearModels(): void;
    protected registerBuiltinAttributes(): void;
    private loadTexture;
}
